/*
  thorfinn thorfinn@binf.ku.dk dec17 2012
  
  part of angsd

  Class that works with counts

  This function


*/


class countCls : public general{
private:
  int dumpCounts;
  int doCounts;
  int doQsDist;//0=nothing 1=overall 2=perbam
  //

  FILE *oFileCountsBin;
  FILE *oFileCountsPos;
  FILE *oFileQs;
  size_t *qsDist;
  
  int minInd;
  int minQ;
  int nInd;//maybe not use this
  int trim;
  int setMaxDepth;
public:

  
  //none optional stuff
  
  countCls(const char *outfiles,argStruct *arguments,int inputtype);
  ~countCls();
  void getOptions(argStruct *arguments);
  void run(funkyPars  *pars);
  void clean(funkyPars *pars);
  void print(funkyPars *pars);
  void printArg(FILE *argFile);

};
void countCls::printArg(FILE *argFile){
  fprintf(argFile,"---------------\n%s:\n",__FILE__);
  fprintf(argFile,"\t-doCounts\t%d\n",doCounts);
  fprintf(argFile,"\t-doQsDist\t%d\t(dump distribution of qscores)\n",doQsDist);
  fprintf(argFile,"\t-dumpCounts\t%d\n",dumpCounts);
  fprintf(argFile,"\t1: depth (sum of all bases for all individuals)\n");
  fprintf(argFile,"\t2: depth for each individual\n");
  fprintf(argFile,"\t3: each allele type for each individuals\n");
  fprintf(argFile,"\t-minQ\t\t%d\t(remove bases with qscore<minQ)\n",minQ);
  fprintf(argFile,"\t-setMaxDepth\t%d\t(-1 indicates no filtering)\n",setMaxDepth);
  fprintf(argFile,"\t-trim\t\t%d\t(trim ends of reads)\n",trim);

  fprintf(argFile,"\t-minInd\t\t%d\t(0 indicates no filtering)\n",minInd);
  fprintf(argFile,"\n");

 
}

int calcSum(suint *counts,int len){
  int tmp=0;
  for(int i=0;i<len;i++)
    tmp += counts[i];
  return tmp;
}

void printCounts(char *chr,int *posi,suint **counts,int nSites,size_t nInd,FILE *oFileCountsPos,FILE *oFileCountsBin,int dumpType,int *keepSites){
  for(int s=0;s<nSites;s++){
    if(keepSites[s]==0)
      continue;
    fprintf(oFileCountsPos,"%s\t%d\t%d\n",chr,posi[s]+1,calcSum(counts[s],4*nInd));
    
    //if we need per sample info
    if(oFileCountsBin) {
      if(dumpType==3)//count A,C,G,T
	for(int i=0;i<4*nInd;i++)
	  fprintf(oFileCountsBin,"%u\t",counts[s][i]);
      else{//print A+C+G+T
	for(int n=0;n<nInd;n++)
	  fprintf(oFileCountsBin,"%u\t",counts[s][n*4]+counts[s][n*4+1]+counts[s][n*4+2]+counts[s][n*4+3]);
      }
      fprintf(oFileCountsBin,"\n");	
    }
  }
}


void countCls::getOptions(argStruct *arguments){

  //from command line
  doCounts=angsd::getArg("-doCounts",doCounts,arguments);
  dumpCounts=angsd::getArg("-dumpCounts",dumpCounts,arguments);
  minQ=angsd::getArg("-minQ",minQ,arguments);
  trim=angsd::getArg("-trim",trim,arguments);
  doQsDist=angsd::getArg("-doQsDist",doQsDist,arguments);
  minInd = angsd::getArg("-minInd",minInd,arguments);
  setMaxDepth = angsd::getArg("-setMaxDepth",setMaxDepth,arguments);
  if(dumpCounts&&doCounts==0){
    fprintf(stderr,"You must supply -doCounts if you want to dumpcounts\n");
    exit(0);
  }


  if(doQsDist){
    qsDist = new size_t[256];
    memset(qsDist,0,256*sizeof(size_t));
    fprintf(stderr,"You should only use nThread 1 og nThreads 2, when summing QS (due to multiprogramming issues)\n");
    
  }

}

countCls::countCls(const char *outfiles,argStruct *arguments,int inputtype){
  minInd =nInd = arguments->nInd;
  trim =0;
  dumpCounts =0;
  doCounts = 0;
  doQsDist = 0;
  minQ =13;
  //from command line

  setMaxDepth = -1;
  if(arguments->argc==2){
    if(!strcmp(arguments->argv[1],"-doCounts")){
      printArg(stdout);
      exit(0);
    }else
      return;
  }

  getOptions(arguments);
  printArg(arguments->argumentFile);
  
  //make output files
  const char* postfix2=".counts";
  const char* postfix1=".pos";
  const char *postfix3=".qs";


  oFileCountsPos = oFileCountsBin = oFileQs = NULL;

  if(dumpCounts){
    oFileCountsPos=openFile(outfiles,postfix1);
    if(dumpCounts>1)
      oFileCountsBin = openFile(outfiles,postfix2);
  }

  if(doQsDist)
    oFileQs = openFile(outfiles,postfix3);
}


void printQs(FILE *fp,size_t *ary){
  for(int i=0;i<256;i++)
    fprintf(fp,"%d\t%lu\n",i,ary[i]);
  
}


countCls::~countCls(){
  if(oFileCountsBin)
    fclose(oFileCountsBin);
  if(oFileCountsPos)
    fclose(oFileCountsPos);
  if(doQsDist){
    printQs(oFileQs,qsDist);
    fclose(oFileQs);
    delete[] qsDist;
  }

}


void countCls::print(funkyPars *pars){

  if(dumpCounts)
    printCounts(header->name[pars->refId],pars->posi,pars->counts,pars->numSites,pars->nInd,oFileCountsPos,oFileCountsBin,dumpCounts,pars->keepSites);

}


void countCls::clean(funkyPars *pars){
  if(doCounts||dumpCounts){
    for(int i=0;i<pars->numSites;i++)
      delete [] pars->counts[i];
    delete [] pars->counts;
  }
}


//dragon update with keeplist so we only count necessary sites
suint **countNucs(const chunkyT *chk,int minQ,int trim,int *keepSites){
  suint **cnts = new suint*[chk->nSites];
  for(int s=0;s<chk->nSites;s++){
    cnts[s] = new suint[4*chk->nSamples];
    if(keepSites[s]==0)
      continue;
    memset(cnts[s],0,4*chk->nSamples*sizeof(suint));
    //loop over samples
    for(int n=0;n<chk->nSamples;n++){
      //loop over persample reads
      for(int l=0;l<chk->nd[s][n].l;l++){
	int allele = refToInt[chk->nd[s][n].seq[l]];
	if(chk->nd[s][n].qs[l] <minQ||chk->nd[s][n].posi[l]<trim||chk->nd[s][n].isop[l]<trim||allele==4){
	  //fprintf(stderr,"ind %d,allele %d\tminQ %d\tQ %d\tMapQ %d\n",n,allele,minQ,chk->nd[s][n].mapQ[l]);
	  continue;
	}
	cnts[s][4*n+allele]++;
      }
    }
  }
  return cnts;
}


void countQs(const chunkyT *chk,size_t *ret,int minQ,int trim,int *keepSites){
  
  suint **cnts = new suint*[chk->nSites];
  for(int s=0;s<chk->nSites;s++){
    if(keepSites[s]==0)
      continue;
    //loop over sites
    for(int n=0;n<chk->nSamples;n++){
      //loop over samples
      for(int l=0;l<chk->nd[s][n].l;l++){
	//loop over persample reads for this position/sample
	if(chk->nd[s][n].qs[l] <minQ||chk->nd[s][n].posi[l]<trim||chk->nd[s][n].isop[l]<trim)
	  continue;
	ret[chk->nd[s][n].qs[l]]++;
	
      }
    }
  }
}




void countCls::run(funkyPars *pars){
  if(doCounts==0)
    return;
  assert(pars->chk!=NULL&&pars->counts==NULL);
  pars->counts = countNucs(pars->chk,minQ,trim,pars->keepSites);

  //modify keepsites;
  if(minInd!=nInd) {
    for(int i=0;i<pars->numSites;i++){
      
      //THIS IS REALLY STUPID but lets count number of samples wiht info
      int nDep =0;
      for(int s=0;s<pars->nInd;s++){
	int dep=0;
	for(int j=0;j<4;j++)
	  dep += pars->counts[i][s*4+j];
	if(dep)
	  nDep++;
      }
      //nDep is now the number of sapmles wiht info
      if(nDep<minInd)
	pars->keepSites[i] = 0;
      else
	pars->keepSites[i] = nDep;
      
    }
  }
  if(setMaxDepth!=-1){
    for(int s=0;s<pars->numSites;s++){
      size_t totSum = calcSum(pars->counts[s],4*nInd);
      if(totSum>setMaxDepth)
	pars->keepSites[s]=0;
      else{
	suint *ps = pars->counts[s];
	for(int i=0;i<pars->nInd;i++){
	  int iSum = ps[i*4]+ps[i*4+1]+ps[i*4+2]+ps[i*4+2]+ps[i*4+3];
	  if(totSum>iSum){
	    pars->keepSites[s]=0;
	    break;
	  }
	}
      }
    }
      

  }
    
  if(doQsDist)
    countQs(pars->chk,qsDist,minQ,trim,pars->keepSites);
    
}
